using System;
using System.Collections;
using System.Diagnostics;
using System.Windows.Forms;
using RootPro.RootProCAD;
using RootPro.RootProCAD.Command;
using RootPro.RootProCAD.Geometry;

//////////////////////////////////////////////////////////////////
// t̃AhC
// 2 ̐}`̊ԂɁAԊuɐ}`쐬܂B
//////////////////////////////////////////////////////////////////

namespace RCAddInAllocationCS
{
    public partial class RootProCADApplication
    {

        string AllocationCommandName = "RootPro.AddIn.AllocationCommand";     //R}h 

        private void RootProCADApplication_Startup(object sender, EventArgs e)
        {
            CommandManager.AddMacroCommand("t", CreateAllocationShape);

            //R}hǉ
            Command command = CommandManager.AddCommand(AllocationCommandName, "t");

            //p[^ǉ
            for (int i = 0; i < 2; i++)
            {
                CommandParameterGroup commandParameterGroup = command.ParameterGroups.Add(ParameterItemType.Shape, i, "}` " + (i + 1));
                ShapeParameterItem parameterItem = (ShapeParameterItem)commandParameterGroup.CurrentItem; // p[^ACe
                parameterItem.ShapeTypeFilter = ShapeTypeFilters.Line | ShapeTypeFilters.Circle;      //ƘÂ
                parameterItem.Description = "A͉~w肵܂B}`^CvIKv܂B";
            }

            command.ParameterGroups.Add(ParameterItemType.Integer, 2, "");
            IntegerParameterItem integerParameterItem = (IntegerParameterItem)command.GetParameterItemByID(2);
            integerParameterItem.Description = "ݒ肵܂Bi 2 ` 100 )";
            integerParameterItem.Value = 2;
            integerParameterItem.ValueSaveMode = ParameterValueSaveMode.Always;

            //JnCxgƏICxg̒ǉ
            command.Begin += new CommandBeginEventHandler(command_Begin);
            command.End += new EventHandler(command_End);

        }

        private void RootProCADApplication_Shutdown(object sender, EventArgs e)
        {
            CommandManager.RemoveMacroCommand(CreateAllocationShape);
            CommandManager.RemoveCommand(AllocationCommandName);
        }

        #region VSTA generated code
        private void InternalStartup()
        {
            this.Startup += new System.EventHandler(RootProCADApplication_Startup);
            this.Shutdown += new System.EventHandler(RootProCADApplication_Shutdown);
        }
        #endregion


        /// <summary>
        /// tR}h
        /// </summary>
        private void CreateAllocationShape()
        {
            //R}h̎s
            CommandManager.ExecuteCommand(AllocationCommandName);
        }

        /// <summary>
        /// R}h̊JnɌĂ΂
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void command_Begin(Object sender, CommandBeginEventArgs e)
        {
            Command command = (Command)sender;

            //p[^ύXCxg̒ǉ
            command.ParameterChanged += new CommandParameterChangedEventHandler(command_ParameterChanged);
        }

        /// <summary>
        /// R}h̏IɌĂ΂
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void command_End(Object sender, EventArgs e)
        {
            Command command = (Command)sender;

            //p[^ύXCxg̍폜
            command.ParameterChanged -= new CommandParameterChangedEventHandler(command_ParameterChanged);
        }

        /// <summary>
        /// ts
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void command_ParameterChanged(Object sender, CommandParameterChangedEventArgs e)
        {
            Document doc = ActiveDocument;         //hLg̎擾

            Command command = (Command)sender;
            int id = e.ParameterID;// ύX̂p[^ID
            ParameterItem parameterItem = command.GetParameterItemByID(id); // p[^ACe

            //}`P̎擾
            ShapeParameterItem shapeParameterItem1 = (ShapeParameterItem)command.GetParameterItemByID(0);
            ShapeParameterItem shapeParameterItem2 = (ShapeParameterItem)command.GetParameterItemByID(1);
            if (shapeParameterItem1.IsEmpty)
            {
                if (!shapeParameterItem2.IsEmpty)
                {
                    Shape shape2a = shapeParameterItem2.Shape.Shape;
                    if (shape2a is LineShape)
                        shapeParameterItem2.ShapeTypeFilter = ShapeTypeFilters.Line;
                    else
                        shapeParameterItem2.ShapeTypeFilter = ShapeTypeFilters.Circle;
                }
                else
                {
                    shapeParameterItem1.ShapeTypeFilter = ShapeTypeFilters.Circle | ShapeTypeFilters.Line;
                    shapeParameterItem2.ShapeTypeFilter = ShapeTypeFilters.Circle | ShapeTypeFilters.Line;
                }
                return;
            }
            Shape shape1 = shapeParameterItem1.Shape.Shape;

            //}`Q̎擾
            if (shapeParameterItem2.IsEmpty)
            {
                if (shape1 is LineShape)
                    shapeParameterItem2.ShapeTypeFilter = ShapeTypeFilters.Line;
                else
                    shapeParameterItem2.ShapeTypeFilter = ShapeTypeFilters.Circle;
                return;
            }
            Shape shape2 = shapeParameterItem2.Shape.Shape;

            //}`^CvH
            if (shape1.GetType() != shape2.GetType())
            {
                MessageBox.Show("^Cv̐}`IĂ");
                return;
            }

            //̎擾
            IntegerParameterItem integerParameterItem = (IntegerParameterItem)command.GetParameterItemByID(2);
            if (integerParameterItem.IsEmpty)
                return;
            int dividCount = integerParameterItem.Value;
            if (dividCount < 2 || dividCount > 100)
            {
                MessageBox.Show(" 2 ` 100 ͈̔͂w肵ĂB");
                return;
            }


            // UNDO \ȑJn
            doc.UndoManager.BeginUndoUnit();

            //Ԍv
            Stopwatch sw = new Stopwatch();
            sw.Start();

            //}`̍쐬
            CreateAllocationShape(shape1, shape2, dividCount);

            //}`p[^ɂ
            command.ParameterChanged -= new CommandParameterChangedEventHandler(command_ParameterChanged);
            shapeParameterItem1.SetEmpty();
            shapeParameterItem2.SetEmpty();
            command.ParameterChanged += new CommandParameterChangedEventHandler(command_ParameterChanged);

            sw.Stop();

            // UNDO \ȑI
            doc.UndoManager.EndUndoUnit();


            long millisec = sw.ElapsedMilliseconds;
            Trace.WriteLine(" "+millisec + " (msec)");
            Trace.Flush();

        }

        /// <summary>
        /// t̎s
        /// </summary>
        /// <param name="shape1"></param>
        /// <param name="shape2"></param>
        /// <param name="dividCount"></param>
        private void CreateAllocationShape(Shape shape1, Shape shape2, int dividCount)
        {
            Document doc = ActiveDocument;         //hLg̎擾
            Drawing drawing = doc.CurrentDrawing;  //}̎擾


            Type type = shape1.GetType();
            if (type.Name == "CircleShapeClass")        //~̕t
            {
                CircleShape circle1 = (CircleShape)shape1;
                CircleShape circle2 = (CircleShape)shape2;

                for (int i = 0; i < dividCount - 1; i++)
                {
                    double cx = circle1.Center.X + (circle2.Center.X - circle1.Center.X) * (i + 1) / dividCount;
                    double cy = circle1.Center.Y + (circle2.Center.Y - circle1.Center.Y) * (i + 1) / dividCount;
                    double radius = circle1.Radius + (circle2.Radius - circle1.Radius) * (i + 1) / dividCount;

                    Point2d centerPoint = Geometry.CreatePoint(cx, cy);

                    CircleShape circleShape = drawing.Shapes.AddCircle(centerPoint, radius);
                }

            }
            else if (type.Name == "LineShapeClass")     //̕t
            {
                LineShape line1 = (LineShape)shape1;
                LineShape line2 = (LineShape)shape2;


                double sx1 = line1.StartPoint.X;
                double sy1 = line1.StartPoint.Y;
                double ex1 = line1.EndPoint.X;
                double ey1 = line1.EndPoint.Y;

                double sx2 = line2.StartPoint.X;
                double sy2 = line2.StartPoint.Y;
                double ex2 = line2.EndPoint.X;
                double ey2 = line2.EndPoint.Y;

                double angle1 = GetAngle(sx1, sy1, ex1, ey1);
                double angle2 = GetAngle(sx2, sy2, ex2, ey2);


                Trace.WriteLine((angle1 * 180.0 / Math.PI).ToString("0.0") + "-" + (angle2 * 180.0 / Math.PI).ToString("0.0"));
                Trace.Flush();

                if (Math.Abs(angle2 - angle1) > Math.PI / 2 && Math.Abs(angle2 - angle1) < Math.PI*3/2)
                {
                    //pxJĂ̂ŁAt_őΉ
                    sx2 = line2.EndPoint.X;
                    sy2 = line2.EndPoint.Y;
                    ex2 = line2.StartPoint.X;
                    ey2 = line2.StartPoint.Y;
                }

                for (int i = 0; i < dividCount - 1; i++)
                {
                    double x1 = sx1 + (sx2 - sx1) * (i + 1) / dividCount;
                    double y1 = sy1 + (sy2 - sy1) * (i + 1) / dividCount;
                    double x2 = ex1 + (ex2 - ex1) * (i + 1) / dividCount;
                    double y2 = ey1 + (ey2 - ey1) * (i + 1) / dividCount;

                    Point2d point1 = Geometry.CreatePoint(x1, y1);
                    Point2d point2 = Geometry.CreatePoint(x2, y2);

                    LineShape lineShape = drawing.Shapes.AddLine(point1, point2);
                }

            }

        }

        /// <summary>
        /// 2_px߂iRAD)
        /// </summary>
        /// <param name="point1"></param>
        /// <param name="point2"></param>
        /// <returns></returns>
        private double GetAngle(double x1, double y1, double x2, double y2)
        {
            double dx = (x2 - x1);
            double dy = (y2 - y1);

            double angle = Math.Atan2(dy, dx);
            //ʒuɂpx𒲐
            if (dx >= 0.0)
            {
                if (dy >= 0.0)
                {
                    if (angle > Math.PI / 2)
                        angle -= Math.PI;
                    else if (angle < 0.0)
                        angle += Math.PI;
                }
                else
                {
                    if (angle > Math.PI / 2)
                        angle -= Math.PI;
                }
            }
            else
            {
                if (dy >= 0.0)
                {
                    if (angle <= Math.PI / 2)
                        angle += Math.PI;
                }
                else
                {
                    if (angle > 0.0)
                        angle -= Math.PI;
                }
            }

            return angle;
        }

    }
}
